package com.tmax.openframe;

import com.tmax.openframe.response.ResponseCode;
import com.tmax.openframe.Handling;
import com.tmax.openframe.option.*;
import com.tmax.openframe.eib.EIB;
import com.tmax.openframe.task.Task;
import com.tmax.openframe.SystemData;
import com.tmax.openframe.support.exception.*;
import com.tmax.openframe.dof.*;
import com.tmax.openframe.dto.*;
import com.tmax.openframe.mapper.*;
import com.tmax.proobject.engine.waitobject.WaitObject;
import com.tmax.openframe.file.*;
import com.tmax.openframe.intervalcontrol.*;
import com.tmax.openframe.taskcontrol.*;
import com.tmax.openframe.tdq.TDQ;
import com.tmax.openframe.tsq.TSQ;
import com.tmax.openframe.command.*;
import java.util.Objects;
import ch.obermuhlner.math.big.BigDecimalMath;
import com.tmax.openframe.dto.OIVPMAIN_InputDto;
import com.tmax.openframe.dto.OIVPMAIN_OutputDto;
import com.tmax.openframe.variable.OIVPMAIN_VariableContainer;
import com.tmax.openframe.variable.condition.*;
import com.tmax.openframe.variable.group.*;
import com.tmax.proobject.engine.waitobject.WaitObject;
import com.tmax.proobject.model.dataobject.DataObject;
import java.lang.Runnable;
import java.math.*;
import java.util.*;
import lombok.*;
import org.apache.commons.lang3.StringUtils;

/** 
 * <p>This source code was generated by COBOL to JAVA migrator</p>
 */
public class OIVPMAIN implements Runnable {
    private @Getter Integer returnValue = 0;
    private @Getter OIVPMAIN_VariableContainer container = new OIVPMAIN_VariableContainer();
    Runnable _0000_MAIN = this::_0000_MAIN;
    Runnable _0100_FIRST_TIME = this::_0100_FIRST_TIME;
    Runnable _0200_MENU = this::_0200_MENU;
    Runnable _0300_BROWSE = this::_0300_BROWSE;
    Runnable _0400_INQUIRY = this::_0400_INQUIRY;
    Runnable _0500_INSERT = this::_0500_INSERT;
    Runnable _0600_UPDATE = this::_0600_UPDATE;
    Runnable _0700_DELETE = this::_0700_DELETE;
    Runnable _0800_CHECK_DATA = this::_0800_CHECK_DATA;
    Runnable _5100_ALWAYS_TEST = this::_5100_ALWAYS_TEST;
    Runnable _5200_INFO = this::_5200_INFO;
    Runnable _5300_RETURN_TRANS_ID = this::_5300_RETURN_TRANS_ID;
    Runnable _5400_QUIT = this::_5400_QUIT;
    Runnable _7100_RECEIVEMAP = this::_7100_RECEIVEMAP;
    Runnable _7200_SENDMAP = this::_7200_SENDMAP;
    Runnable _7250_SENDMAP_DATA = this::_7250_SENDMAP_DATA;
    Runnable _9100_INVALID_KEY = this::_9100_INVALID_KEY;
    Runnable _9200_INVALID_CODE = this::_9200_INVALID_CODE;
    Runnable _9999_ABORT = this::_9999_ABORT;
    Runnable GoTo;
    boolean Return;
    ArrayList<Runnable> MethodFlow = new ArrayList<>();
    {
        MethodFlow.add(_0000_MAIN);
        MethodFlow.add(_0100_FIRST_TIME);
        MethodFlow.add(_0200_MENU);
        MethodFlow.add(_0300_BROWSE);
        MethodFlow.add(_0400_INQUIRY);
        MethodFlow.add(_0500_INSERT);
        MethodFlow.add(_0600_UPDATE);
        MethodFlow.add(_0700_DELETE);
        MethodFlow.add(_0800_CHECK_DATA);
        MethodFlow.add(_5100_ALWAYS_TEST);
        MethodFlow.add(_5200_INFO);
        MethodFlow.add(_5300_RETURN_TRANS_ID);
        MethodFlow.add(_5400_QUIT);
        MethodFlow.add(_7100_RECEIVEMAP);
        MethodFlow.add(_7200_SENDMAP);
        MethodFlow.add(_7250_SENDMAP_DATA);
        MethodFlow.add(_9100_INVALID_KEY);
        MethodFlow.add(_9200_INVALID_CODE);
        MethodFlow.add(_9999_ABORT);
    }
    @Getter
    EIB eib = new Task().getEib();
    @Getter
    boolean Start;
    @Getter
    Handling handling = new Handling();
    @Getter
    SystemData systemData = new SystemData();
    @Getter
    @Setter
    WaitObject waitObject;
    @Getter
    @Setter
    OIVPMAIN_InputDto inputDto;
    @Getter
    @Setter
    OIVPMAIN_OutputDto outputDto;
    @Getter
    @Setter
    DataObject startInputDto;

    public OIVPMAIN() {
        container.setDFHCOMMAREA(StringUtils.repeat(' ', 1));
    }

    public @Override void run() {
        run(_0000_MAIN, _9999_ABORT);
    }

    private void run(Runnable start) throws CicsException {
        run(start, null);
    }

    private void run(Runnable start, Runnable end) throws CicsException {
        List<Runnable> runList;
        if (end == null) {
            runList = Collections.singletonList(start);
        } else {
            runList = MethodFlow.subList(MethodFlow.indexOf(start),
                    MethodFlow.indexOf(end) + 1);
        }
        int i = 0;
        while (i < runList.size()) {
            runList.get(i).run();
            if (GoTo != null) {
                for (Runnable runUnit : runList) {
                    if (GoTo == runUnit) {
                        i = runList.indexOf(runUnit);
                        GoTo = null;
                        break;
                    }
                }
                if (GoTo != null) {
                    return;
                }
            } else {
                i++;
            }
            if (Return) {
                return;
            }
        }
    }

    void _0000_MAIN() throws CicsException {
        run(_5100_ALWAYS_TEST);
        if (GoTo != null || Return) {
            return;
        }
        if (OIVPMAIN_WS_FIRST_TIME_FLAG_CONDITION.FIRST_TIME.test(container
                .getWS_FIRST_TIME_FLAG())) {
            run(_0100_FIRST_TIME);
            if (GoTo != null || Return) {
                return;
            }
        } else if (OIVPMAIN_DEFINITIONS_OF_EIBAID_FIELD_CONDITION.ENTER_KEY
                .test(container.getDEFINITIONS_OF_EIBAID_FIELD())) {
            run(_0200_MENU);
            if (GoTo != null || Return) {
                return;
            }
        } else {
            run(_9100_INVALID_KEY);
            if (GoTo != null || Return) {
                return;
            }
        }
        run(_5300_RETURN_TRANS_ID);
        if (GoTo != null || Return) {
            return;
        }
    }

    void _0100_FIRST_TIME() throws CicsException {
        container.setOIVPM01I(OIVPMAIN_OIVPM01I.createDefaultValueInstance());
        container.setMSGO("ENTER APPROPRIATE CODE OR ID");
        run(_5200_INFO);
        if (GoTo != null || Return) {
            return;
        }
        run(_7200_SENDMAP);
        if (GoTo != null || Return) {
            return;
        }
    }

    void _0200_MENU() throws CicsException {
        run(_7100_RECEIVEMAP);
        if (GoTo != null || Return) {
            return;
        }
        switch (container.getOIVPM01I().getCODEI()) {
        case "BROS": {
            run(_0300_BROWSE);
            if (GoTo != null || Return) {
                return;
            }
            break;
        }
        case "INQR": {
            run(_0400_INQUIRY);
            if (GoTo != null || Return) {
                return;
            }
            break;
        }
        case "INSR": {
            run(_0500_INSERT);
            if (GoTo != null || Return) {
                return;
            }
            break;
        }
        case "UPDT": {
            run(_0600_UPDATE);
            if (GoTo != null || Return) {
                return;
            }
            break;
        }
        case "DELT": {
            run(_0700_DELETE);
            if (GoTo != null || Return) {
                return;
            }
            break;
        }
        default: {
            run(_9200_INVALID_CODE);
            if (GoTo != null || Return) {
                return;
            }
        }
        }
    }

    void _0300_BROWSE() throws CicsException {
        // ("EXEC CICS STARTBR FILE(FILE01) RIDFLD(START-KEY) KEYLENGTH(LEN) RESP(WS-RESPONSE-CODE) END-EXEC");
        try {
            StartbrOption option = StartbrOption.builder()
                    .file(container.getFILE01())
                    .ridfld(String.valueOf(container.getSTART_KEY()))
                    .keylength((int) container.getLEN()).build();
            File.startbr(option, OIVPDS_DOF.class);
            container.setSTART_KEY(Integer.parseInt(option.getRidfld()));
        } catch (CicsConditionException e) {
        } catch (RuntimeException e) {
            GoTo = systemData.getErrorRunnable(e);
        } finally {
            container.setWS_RESPONSE_CODE(eib.getEibResp());
            if (GoTo != null)
                return;
        }
        if (container.getWS_RESPONSE_CODE() != ResponseCode.NORMAL
                .getResponseCode()) {
            container.setMSGO("DATA DOES NOT EXIST");
            run(_7250_SENDMAP_DATA);
            if (GoTo != null || Return) {
                return;
            }
            run(_5300_RETURN_TRANS_ID);
            if (GoTo != null || Return) {
                return;
            }
        }
        // ("EXEC CICS START TRANSID('OIBR') TERMID(EIBTRMID) RESP(WS-RESPONSE-CODE) END-EXEC");
        try {
            StartOption option = StartOption.builder().transid("OIBR")
                    .termid(eib.getEibTrmid())
                    .inputDto(new OIVPBROS_InputDto()).build();
            IntervalControlService.start(option);
            WaitObject object = option.getWaitObject();
            setWaitObject(object);
            Start = true;
        } catch (CicsConditionException e) {
        } catch (RuntimeException e) {
            GoTo = systemData.getErrorRunnable(e);
        } finally {
            container.setWS_RESPONSE_CODE(eib.getEibResp());
            if (GoTo != null)
                return;
        }
        run(_5300_RETURN_TRANS_ID);
        if (GoTo != null || Return) {
            return;
        }
    }

    void _0400_INQUIRY() throws CicsException {
        container.getPEOPLE_INFO_GET().setWS_KEY(
                container.getOIVPM01I().getIDENI());
        run(_0800_CHECK_DATA);
        if (GoTo != null || Return) {
            return;
        }
        // ("EXEC CICS ENQ RESOURCE('OIVPTDQW') LENGTH(8) END-EXEC");
        try {
            EnqOption option = EnqOption.builder().resource("OIVPTDQW")
                    .length(8).build();
            TaskControl.enq(option);
        } catch (CicsConditionException e) {
            GoTo = systemData.getConditionRunnable(e);
        } catch (RuntimeException e) {
            GoTo = systemData.getErrorRunnable(e);
        } finally {
            if (GoTo != null)
                return;
        }
        // ("EXEC CICS WRITEQ TD QUEUE(TDQ01) FROM(PEOPLE-INFO-GET) LENGTH(DATALEN) END-EXEC");
        try {
            WriteqTDOption option = WriteqTDOption
                    .builder()
                    .queue(container.getTDQ01())
                    .from(OIVPMAIN_PEOPLE_INFO_GET_To_OIVPMAIN_PEOPLE_INFO_GET_DOMapper.INSTANCE
                            .toTarget(container.getPEOPLE_INFO_GET()))
                    .length((int) container.getDATALEN()).build();
            TDQ.write(option);
        } catch (CicsConditionException e) {
            GoTo = systemData.getConditionRunnable(e);
        } catch (RuntimeException e) {
            GoTo = systemData.getErrorRunnable(e);
        } finally {
            if (GoTo != null)
                return;
        }
        // ("EXEC CICS DEQ RESOURCE('OIVPTDQW') LENGTH(8) END-EXEC");
        try {
            DeqOption option = DeqOption.builder().resource("OIVPTDQW")
                    .length(8).build();
            TaskControl.deq(option);
        } catch (CicsConditionException e) {
            GoTo = systemData.getConditionRunnable(e);
        } catch (RuntimeException e) {
            GoTo = systemData.getErrorRunnable(e);
        } finally {
            if (GoTo != null)
                return;
        }
        // ("EXEC CICS START TRANSID('OIIQ') TERMID(EIBTRMID) RESP(WS-RESPONSE-CODE) END-EXEC");
        try {
            StartOption option = StartOption.builder().transid("OIIQ")
                    .termid(eib.getEibTrmid())
                    .inputDto(new OIVPINQR_InputDto()).build();
            IntervalControlService.start(option);
            WaitObject object = option.getWaitObject();
            setWaitObject(object);
            Start = true;
        } catch (CicsConditionException e) {
        } catch (RuntimeException e) {
            GoTo = systemData.getErrorRunnable(e);
        } finally {
            container.setWS_RESPONSE_CODE(eib.getEibResp());
            if (GoTo != null)
                return;
        }
        run(_5300_RETURN_TRANS_ID);
        if (GoTo != null || Return) {
            return;
        }
    }

    void _0500_INSERT() throws CicsException {
        // ("EXEC CICS START TRANSID('OIIS') TERMID(EIBTRMID) RESP(WS-RESPONSE-CODE) END-EXEC");
        try {
            StartOption option = StartOption.builder().transid("OIIS")
                    .termid(eib.getEibTrmid())
                    .inputDto(new OIVPINSR_InputDto()).build();
            IntervalControlService.start(option);
            WaitObject object = option.getWaitObject();
            setWaitObject(object);
            Start = true;
        } catch (CicsConditionException e) {
        } catch (RuntimeException e) {
            GoTo = systemData.getErrorRunnable(e);
        } finally {
            container.setWS_RESPONSE_CODE(eib.getEibResp());
            if (GoTo != null)
                return;
        }
        run(_5300_RETURN_TRANS_ID);
        if (GoTo != null || Return) {
            return;
        }
    }

    void _0600_UPDATE() throws CicsException {
        container.getPEOPLE_INFO_GET().setWS_KEY(
                container.getOIVPM01I().getIDENI());
        run(_0800_CHECK_DATA);
        if (GoTo != null || Return) {
            return;
        }
        // ("EXEC CICS WRITEQ TS QUEUE(TSQ01) FROM(WS-KEY) LENGTH(LEN1) ITEM(ITEM01) END-EXEC");
        try {
            WriteqTSOption option = WriteqTSOption.builder()
                    .queue(container.getTSQ01())
                    .from(container.getPEOPLE_INFO_GET().getWS_KEY()).build();
            TSQ.write(option);
        } catch (CicsConditionException e) {
            GoTo = systemData.getConditionRunnable(e);
        } catch (RuntimeException e) {
            GoTo = systemData.getErrorRunnable(e);
        } finally {
            if (GoTo != null)
                return;
        }
        // ("EXEC CICS START TRANSID('OIUP') TERMID(EIBTRMID) RESP(WS-RESPONSE-CODE) END-EXEC");
        try {
            StartOption option = StartOption.builder().transid("OIUP")
                    .termid(eib.getEibTrmid())
                    .inputDto(new OIVPUPDT_InputDto()).build();
            IntervalControlService.start(option);
            WaitObject object = option.getWaitObject();
            setWaitObject(object);
            Start = true;
        } catch (CicsConditionException e) {
        } catch (RuntimeException e) {
            GoTo = systemData.getErrorRunnable(e);
        } finally {
            container.setWS_RESPONSE_CODE(eib.getEibResp());
            if (GoTo != null)
                return;
        }
        run(_5300_RETURN_TRANS_ID);
        if (GoTo != null || Return) {
            return;
        }
    }

    void _0700_DELETE() throws CicsException {
        container.getPEOPLE_INFO_GET().setWS_KEY(
                container.getOIVPM01I().getIDENI());
        run(_0800_CHECK_DATA);
        if (GoTo != null || Return) {
            return;
        }
        // ("EXEC CICS WRITEQ TS QUEUE(TSQ01) FROM(WS-KEY) LENGTH(LEN1) ITEM(ITEM01) END-EXEC");
        try {
            WriteqTSOption option = WriteqTSOption.builder()
                    .queue(container.getTSQ01())
                    .from(container.getPEOPLE_INFO_GET().getWS_KEY()).build();
            TSQ.write(option);
        } catch (CicsConditionException e) {
            GoTo = systemData.getConditionRunnable(e);
        } catch (RuntimeException e) {
            GoTo = systemData.getErrorRunnable(e);
        } finally {
            if (GoTo != null)
                return;
        }
        // ("EXEC CICS START TRANSID('OIDE') TERMID(EIBTRMID) RESP(WS-RESPONSE-CODE) END-EXEC");
        try {
            StartOption option = StartOption.builder().transid("OIDE")
                    .termid(eib.getEibTrmid())
                    .inputDto(new OIVPDELT_InputDto()).build();
            IntervalControlService.start(option);
            WaitObject object = option.getWaitObject();
            setWaitObject(object);
            Start = true;
        } catch (CicsConditionException e) {
        } catch (RuntimeException e) {
            GoTo = systemData.getErrorRunnable(e);
        } finally {
            container.setWS_RESPONSE_CODE(eib.getEibResp());
            if (GoTo != null)
                return;
        }
        run(_5300_RETURN_TRANS_ID);
        if (GoTo != null || Return) {
            return;
        }
    }

    void _0800_CHECK_DATA() throws CicsException {
        // ("EXEC CICS READ FILE(FILE01) RIDFLD(WS-KEY) KEYLENGTH(LEN) EQUAL INTO(PEOPLE-INFO-GET) LENGTH(DATALEN) RESP(WS-RESPONSE-CODE) END-EXEC");
        try {
            ReadOption option = ReadOption
                    .builder()
                    .file(container.getFILE01())
                    .ridfld(String.valueOf(container.getPEOPLE_INFO_GET()
                            .getWS_KEY()))
                    .keylength((int) container.getLEN())
                    .equal(true)
                    .into(OIVPMAIN_PEOPLE_INFO_GET_To_OIVPDS_DOMapper.INSTANCE
                            .toTarget(container.getPEOPLE_INFO_GET()))
                    .length((int) container.getDATALEN()).build();
            File.read(option, OIVPDS_DOF.class);
            container
                    .setPEOPLE_INFO_GET(OIVPMAIN_PEOPLE_INFO_GET_To_OIVPDS_DOMapper.INSTANCE
                            .toSource((OIVPDS_DO) option.getInto()));
            container.getPEOPLE_INFO_GET().setWS_KEY(
                    Integer.parseInt(option.getRidfld()));
        } catch (CicsConditionException e) {
        } catch (RuntimeException e) {
            GoTo = systemData.getErrorRunnable(e);
        } finally {
            container.setWS_RESPONSE_CODE(eib.getEibResp());
            if (GoTo != null)
                return;
        }
        if (container.getWS_RESPONSE_CODE() == ResponseCode.NORMAL
                .getResponseCode()) {
        } else if (container.getWS_RESPONSE_CODE() == ResponseCode.NOTFND
                .getResponseCode()) {
            container.setOIVPM01I(OIVPMAIN_OIVPM01I
                    .createDefaultValueInstance());
            container.setMSGO("ID ERROR");
            run(_7200_SENDMAP);
            if (GoTo != null || Return) {
                return;
            }
            run(_5300_RETURN_TRANS_ID);
            if (GoTo != null || Return) {
                return;
            }
        }
    }

    void _5100_ALWAYS_TEST() throws CicsException {
        container.setDEFINITIONS_OF_EIBAID_FIELD(eib.getEibAid());
        if (OIVPMAIN_DEFINITIONS_OF_EIBAID_FIELD_CONDITION.CLEAR_KEY
                .test(container.getDEFINITIONS_OF_EIBAID_FIELD())) {
            run(_5400_QUIT);
            if (GoTo != null || Return) {
                return;
            }
        }
        // ("EXEC CICS ASSIGN STARTCODE(START-CODE) END-EXEC");
        try {
            AssignOption option = AssignOption.builder()
                    .startcode(container.getSTART_CODE()).inputDto(inputDto)
                    .build();
            SystemEnv.assign(option);
            container.setSTART_CODE(option.getStartcode());
        } catch (CicsConditionException e) {
            GoTo = systemData.getConditionRunnable(e);
        } catch (RuntimeException e) {
            GoTo = systemData.getErrorRunnable(e);
        } finally {
            if (GoTo != null)
                return;
        }
        if (StringUtils.stripEnd(container.getSTART_CODE(), " ")
                .compareTo("TD") == 0 && eib.getEibCalen() != 0) {
            container.setWS_FIRST_TIME_FLAG(1);
        } else {
            container.setWS_FIRST_TIME_FLAG(0);
        }
    }

    void _5200_INFO() throws CicsException {
        // ("EXEC CICS LINK PROGRAM ('OIVPINFO') COMMAREA (WS-DATE-TIME-AREA) END-EXEC");
        try {
            LinkOption option = LinkOption
                    .builder()
                    .program("OIVPINFO")
                    .commarea(
                            OIVPMAIN_WS_DATE_TIME_AREA_To_OIVPINFO_DFHCOMMAREADtoMapper.INSTANCE
                                    .toOIVPINFO_DFHCOMMAREADto(container
                                            .getWS_DATE_TIME_AREA()))
                    .inputDto(new OIVPINFO_InputDto()).build();
            ProgramInvoke.link(option);
            container
                    .setWS_DATE_TIME_AREA(OIVPMAIN_WS_DATE_TIME_AREA_To_OIVPINFO_DFHCOMMAREADtoMapper.INSTANCE
                            .toOIVPMAIN_WS_DATE_TIME_AREA((OIVPINFO_DFHCOMMAREADto) option
                                    .getCommarea()));
        } catch (CicsConditionException e) {
            GoTo = systemData.getConditionRunnable(e);
        } catch (RuntimeException e) {
            GoTo = systemData.getErrorRunnable(e);
        } finally {
            if (GoTo != null)
                return;
        }
        container.setDATEO(container.getWS_DATE_TIME_AREA().getDCA_DATE());
        container.setTERMO(container.getWS_DATE_TIME_AREA().getDCA_TERM());
        container.setTIMEO(container.getWS_DATE_TIME_AREA().getDCA_TIME()
                .toString());
    }

    void _5300_RETURN_TRANS_ID() throws CicsException {
        // ("EXEC CICS RETURN TRANSID ('OIVP') COMMAREA (WS-COMMUNICATION-AREA) END-EXEC");
        try {
            OIVPMAIN_DFHCOMMAREADto dfhcommareaDto = new OIVPMAIN_DFHCOMMAREADto();
            dfhcommareaDto.setDFHCOMMAREA(container.getWS_COMMUNICATION_AREA());
            ReturnOption option = ReturnOption.builder().transid("OIVP")
                    .commarea(dfhcommareaDto).outputDto(outputDto).build();
            ProgramInvoke.returnProgram(option);
            Return = true;
        } catch (CicsConditionException e) {
            GoTo = systemData.getConditionRunnable(e);
        } catch (RuntimeException e) {
            GoTo = systemData.getErrorRunnable(e);
        } finally {
            if (GoTo != null)
                return;
        }
    }

    void _5400_QUIT() throws CicsException {
        // ("EXEC CICS START TRANSID('OIQU') AFTER SECONDS(5) TERMID(EIBTRMID) RESP(WS-RESPONSE-CODE) END-EXEC");
        try {
            StartOption option = StartOption.builder().transid("OIQU")
                    .after(true).isDuration(true).seconds(5)
                    .termid(eib.getEibTrmid())
                    .inputDto(new OIVPQUIT_InputDto()).build();
            IntervalControlService.start(option);
            WaitObject object = option.getWaitObject();
            setWaitObject(object);
            Start = true;
        } catch (CicsConditionException e) {
        } catch (RuntimeException e) {
            GoTo = systemData.getErrorRunnable(e);
        } finally {
            container.setWS_RESPONSE_CODE(eib.getEibResp());
            if (GoTo != null)
                return;
        }
        // ("EXEC CICS RETURN END-EXEC");
        try {
            if (Objects.equals("DS", inputDto.getSystemDto().getStartCode())
                    || Objects.equals("D", inputDto.getSystemDto()
                            .getStartCode())) {
                OIVPMAIN_DFHCOMMAREADto dfhcommareaDto = new OIVPMAIN_DFHCOMMAREADto();
                dfhcommareaDto.setDFHCOMMAREA(container.getDFHCOMMAREA());
                outputDto.getSystemDto().setCommarea("DFHCOMMAREA",
                        dfhcommareaDto);
            }
            ReturnOption option = ReturnOption.builder().outputDto(outputDto)
                    .build();
            ProgramInvoke.returnProgram(option);
            Return = true;
        } catch (CicsConditionException e) {
            GoTo = systemData.getConditionRunnable(e);
        } catch (RuntimeException e) {
            GoTo = systemData.getErrorRunnable(e);
        } finally {
            if (GoTo != null)
                return;
        }
    }

    void _7100_RECEIVEMAP() throws CicsException {
        // ("EXEC CICS RECEIVE MAP('OIVPM01') MAPSET('OIVPM01') INTO(OIVPM01I) RESP(WS-RESPONSE-CODE) END-EXEC");
        try {
            ReceiveMapOption option = ReceiveMapOption.builder().build();
            OIVPM01_OIVPM01_dataToOIVPMAIN_OIVPM01IMapperInterface.INSTANCE
                    .toTarget(
                            inputDto.getScreenDto().getOIVPM01_OIVPM01_data(),
                            container.getOIVPM01I());
            OIVPM01_OIVPM01_metaToOIVPMAIN_OIVPM01IMapperInterface.INSTANCE
                    .toTarget(
                            inputDto.getScreenDto().getOIVPM01_OIVPM01_meta(),
                            container.getOIVPM01I());
        } catch (CicsConditionException e) {
        } catch (RuntimeException e) {
            GoTo = systemData.getErrorRunnable(e);
        } finally {
            container.setWS_RESPONSE_CODE(eib.getEibResp());
            if (GoTo != null)
                return;
        }
        if (container.getWS_RESPONSE_CODE() == ResponseCode.NORMAL
                .getResponseCode()) {
        } else if (container.getWS_RESPONSE_CODE() == ResponseCode.MAPFAIL
                .getResponseCode()) {
            container.setMSGO("NO CODE OR ID ENTERED");
            run(_7250_SENDMAP_DATA);
            if (GoTo != null || Return) {
                return;
            }
            run(_5300_RETURN_TRANS_ID);
            if (GoTo != null || Return) {
                return;
            }
        } else {
            run(_9999_ABORT);
            if (GoTo != null || Return) {
                return;
            }
        }
    }

    void _7200_SENDMAP() throws CicsException {
        // ("EXEC CICS SEND MAP('OIVPM01') MAPSET('OIVPM01') FROM(OIVPM01O) ERASE END-EXEC");
        try {
            outputDto.setScreenDto(new OIVPMAIN_ScreenDto());
            outputDto.setId("tranExecute");
            outputDto.getScreenDto().setMapName("OIVPM01");
            outputDto.getScreenDto().setMapSetName("OIVPM01");
            try {
                OIVPM01_OIVPM01_data oivpm01_oivpm01_data = new OIVPM01_OIVPM01_data();
                OIVPM01_OIVPM01_meta oivpm01_oivpm01_meta = new OIVPM01_OIVPM01_meta();
                OIVPMAIN_OIVPM01OToOIVPM01_OIVPM01_dataMapperInterface.INSTANCE
                        .toTarget(container.getOIVPM01O(), oivpm01_oivpm01_data);
                OIVPMAIN_OIVPM01OToOIVPM01_OIVPM01_metaMapperInterface.INSTANCE
                        .toTarget(container.getOIVPM01O(), oivpm01_oivpm01_meta);
                outputDto.getScreenDto().setOIVPM01_OIVPM01_data(
                        oivpm01_oivpm01_data);
                outputDto.getScreenDto().setOIVPM01_OIVPM01_meta(
                        oivpm01_oivpm01_meta);
            } catch (Exception e) {
                throw new CicsConditionException(47);
            }
        } catch (CicsConditionException e) {
            GoTo = systemData.getConditionRunnable(e);
        } catch (RuntimeException e) {
            GoTo = systemData.getErrorRunnable(e);
        } finally {
            if (GoTo != null)
                return;
        }
    }

    void _7250_SENDMAP_DATA() throws CicsException {
        // ("EXEC CICS SEND MAP('OIVPM01') MAPSET('OIVPM01') FROM(OIVPM01O) DATAONLY END-EXEC");
        try {
            outputDto.setScreenDto(new OIVPMAIN_ScreenDto());
            outputDto.setId("tranExecute");
            outputDto.getScreenDto().setMapName("OIVPM01");
            outputDto.getScreenDto().setMapSetName("OIVPM01");
            try {
                OIVPM01_OIVPM01_data oivpm01_oivpm01_data = new OIVPM01_OIVPM01_data();
                OIVPM01_OIVPM01_meta oivpm01_oivpm01_meta = new OIVPM01_OIVPM01_meta();
                OIVPMAIN_OIVPM01OToOIVPM01_OIVPM01_dataMapperInterface.INSTANCE
                        .toTarget(container.getOIVPM01O(), oivpm01_oivpm01_data);
                OIVPMAIN_OIVPM01OToOIVPM01_OIVPM01_metaMapperInterface.INSTANCE
                        .toTarget(container.getOIVPM01O(), oivpm01_oivpm01_meta);
                outputDto.getScreenDto().setOIVPM01_OIVPM01_data(
                        oivpm01_oivpm01_data);
                outputDto.getScreenDto().setOIVPM01_OIVPM01_meta(
                        oivpm01_oivpm01_meta);
            } catch (Exception e) {
                throw new CicsConditionException(47);
            }
        } catch (CicsConditionException e) {
            GoTo = systemData.getConditionRunnable(e);
        } catch (RuntimeException e) {
            GoTo = systemData.getErrorRunnable(e);
        } finally {
            if (GoTo != null)
                return;
        }
    }

    void _9100_INVALID_KEY() throws CicsException {
        System.out.println("9100-INVALID-KEY");
        container.setOIVPM01I(OIVPMAIN_OIVPM01I.createDefaultValueInstance());
        container.setMSGO("INVALID KEY ENTERED");
        run(_7250_SENDMAP_DATA);
        if (GoTo != null || Return) {
            return;
        }
    }

    void _9200_INVALID_CODE() throws CicsException {
        System.out.println("9200-INVALID-CODE");
        container.setOIVPM01I(OIVPMAIN_OIVPM01I.createDefaultValueInstance());
        container.setMSGO("INVALID CODE ENTERED");
        run(_7250_SENDMAP_DATA);
        if (GoTo != null || Return) {
            return;
        }
    }

    void _9999_ABORT() throws CicsException {
        container.getWS_ERROR_MESSAGE().setWS_EIBTRNID(eib.getEibTranid());
        container.getWS_ERROR_MESSAGE().setWS_EIBRSRCE(eib.getEibRsrce());
        container.getWS_ERROR_MESSAGE().setWS_EIBRESP(eib.getEibResp());
        container.getWS_ERROR_MESSAGE().setWS_EIBRESP2(eib.getEibResp2());
        // ("EXEC CICS SEND TEXT FROM(\"aaaa\") ERASE ALARM FREEKB END-EXEC");
        try {
            outputDto.getScreenDto().setText("aaaa");
        } catch (CicsConditionException e) {
            GoTo = systemData.getConditionRunnable(e);
        } catch (RuntimeException e) {
            GoTo = systemData.getErrorRunnable(e);
        } finally {
            if (GoTo != null)
                return;
        }
        // ("EXEC CICS RETURN END-EXEC");
        try {
            if (Objects.equals("DS", inputDto.getSystemDto().getStartCode())
                    || Objects.equals("D", inputDto.getSystemDto()
                            .getStartCode())) {
                OIVPMAIN_DFHCOMMAREADto dfhcommareaDto = new OIVPMAIN_DFHCOMMAREADto();
                dfhcommareaDto.setDFHCOMMAREA(container.getDFHCOMMAREA());
                outputDto.getSystemDto().setCommarea("DFHCOMMAREA",
                        dfhcommareaDto);
            }
            ReturnOption option = ReturnOption.builder().outputDto(outputDto)
                    .build();
            ProgramInvoke.returnProgram(option);
            Return = true;
        } catch (CicsConditionException e) {
            GoTo = systemData.getConditionRunnable(e);
        } catch (RuntimeException e) {
            GoTo = systemData.getErrorRunnable(e);
        } finally {
            if (GoTo != null)
                return;
        }
    }
}
